searchNodes=[{"ref":"FastHtml.Pool.html","title":"FastHtml.Pool","type":"module","doc":""},{"ref":"FastHtml.Pool.html#get_port/2","title":"FastHtml.Pool.get_port/2","type":"function","doc":""},{"ref":"FastHtml.Pool.html#start_link/1","title":"FastHtml.Pool.start_link/1","type":"function","doc":"Starts the port pool. Options :size - Number of ports in the pool. Defaults to System.schedulers_online/0 if not set. :name - Registered name of the pool. Defaults to Elixir.FastHtml.Pool if not set, set to false to not register the process."},{"ref":"FastHtml.Pool.html#t:option/0","title":"FastHtml.Pool.option/0","type":"type","doc":""},{"ref":"FastHtml.Pool.html#t:pool/0","title":"FastHtml.Pool.pool/0","type":"type","doc":""},{"ref":"FastHtml.Pool.html#t:result/0","title":"FastHtml.Pool.result/0","type":"type","doc":""},{"ref":"fast_html.html","title":"fast_html","type":"module","doc":"A module to decode html into a tree structure."},{"ref":"fast_html.html#decode/2","title":"fast_html.decode/2","type":"function","doc":"Returns a tree representation from the given html string. opts is a keyword list of options, the options available: timeout - Call timeout. If pooling is used and the worker doesn&#39;t return the result in time, the worker will be killed with a warning. format - Format flags for the tree. The following format flags are available: :html_atoms uses atoms for known html tags (faster), binaries for everything else. :nil_self_closing uses nil to designate void elements. For example &lt;br&gt; is then being represented like {&quot;br&quot;, [], nil}. See http://w3c.github.io/html-reference/syntax.html#void-elements for a full list of void elements. :comment_tuple3 uses 3-tuple elements for comments, instead of the default 2-tuple element. Examples iex&gt; :fast_html.decode(&quot;&lt;h1&gt;Hello world&lt;/h1&gt;&quot;) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Hello world&quot;]}]}]}]} iex&gt; :fast_html.decode(&quot;Hello world&quot;, timeout: 0) {:error, :timeout} iex&gt; :fast_html.decode(&quot;&lt;span class=&#39;hello&#39;&gt;Hi there&lt;/span&gt;&quot;) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;span&quot;, [{&quot;class&quot;, &quot;hello&quot;}], [&quot;Hi there&quot;]}]}]}]} iex&gt; :fast_html.decode(&quot;&lt;body&gt;&lt;!-- a comment --!&gt;&lt;/body&gt;&quot;) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [comment: &quot; a comment &quot;]}]}]} iex&gt; :fast_html.decode(&quot;&lt;br&gt;&quot;) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;br&quot;, [], []}]}]}]} iex&gt; :fast_html.decode(&quot;&lt;h1&gt;Hello world&lt;/h1&gt;&quot;, format: [:html_atoms]) {:ok, [{:html, [], [{:head, [], []}, {:body, [], [{:h1, [], [&quot;Hello world&quot;]}]}]}]} iex&gt; :fast_html.decode(&quot;&lt;br&gt;&quot;, format: [:nil_self_closing]) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;br&quot;, [], nil}]}]}]} iex&gt; :fast_html.decode(&quot;&lt;body&gt;&lt;!-- a comment --!&gt;&lt;/body&gt;&quot;, format: [:comment_tuple3]) {:ok, [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{:comment, [], &quot; a comment &quot;}]}]}]} iex&gt; html = &quot;&lt;body&gt;&lt;!-- a comment --!&gt;&lt;unknown /&gt;&lt;/body&gt;&quot; iex&gt; :fast_html.decode(html, format: [:html_atoms, :nil_self_closing, :comment_tuple3]) {:ok, [{:html, [], [{:head, [], []}, {:body, [], [{:comment, [], &quot; a comment &quot;}, {&quot;unknown&quot;, [], []}]}]}]}"},{"ref":"fast_html.html#decode_fragment/2","title":"fast_html.decode_fragment/2","type":"function","doc":"Like decode/2, but for parsing HTML fragments. opts is a keyword list of options, the options available are the same as in decode/2 with addition of: context - Name of the context element, defaults to div Example: iex&gt; :fast_html.decode_fragment(&quot;rin is the &lt;i&gt;best&lt;/i&gt; girl&quot;) {:ok, [&quot;rin is the &quot;, {&quot;i&quot;, [], [&quot;best&quot;]}, &quot; girl&quot;]} iex&gt; :fast_html.decode_fragment(&quot;rin is the &lt;i&gt;best&lt;/i&gt; girl&quot;, context: &quot;title&quot;) {:ok, [&quot;rin is the &lt;i&gt;best&lt;/i&gt; girl&quot;]} iex&gt; :fast_html.decode_fragment(&quot;rin is the &lt;i&gt;best&lt;/i&gt; girl&quot;, context: &quot;objective_truth&quot;) {:error, :unknown_context_tag} iex&gt; :fast_html.decode_fragment(&quot;rin is the &lt;i&gt;best&lt;/i&gt; girl&quot;, format: [:html_atoms]) {:ok, [&quot;rin is the &quot;, {:i, [], [&quot;best&quot;]}, &quot; girl&quot;]}"},{"ref":"fast_html.html#open_port/0","title":"fast_html.open_port/0","type":"function","doc":""},{"ref":"fast_html.html#t:attr/0","title":"fast_html.attr/0","type":"type","doc":""},{"ref":"fast_html.html#t:attr_list/0","title":"fast_html.attr_list/0","type":"type","doc":""},{"ref":"fast_html.html#t:comment_node/0","title":"fast_html.comment_node/0","type":"type","doc":""},{"ref":"fast_html.html#t:comment_node3/0","title":"fast_html.comment_node3/0","type":"type","doc":""},{"ref":"fast_html.html#t:format_flag/0","title":"fast_html.format_flag/0","type":"type","doc":""},{"ref":"fast_html.html#t:tag/0","title":"fast_html.tag/0","type":"type","doc":""},{"ref":"fast_html.html#t:tree/0","title":"fast_html.tree/0","type":"type","doc":""},{"ref":"readme.html","title":"FastHTML","type":"extras","doc":"FastHTML A C Node wrapping lexborisov&#39;s myhtml. Primarily used with FastSanitize. Available as a hex package: {:fast_html, &quot;~&gt; 2.0&quot;} Documentation"},{"ref":"readme.html#benchmarks","title":"FastHTML - Benchmarks","type":"extras","doc":"The following table provides median times it takes to decode a string to a tree for html parsers that can be used from Elixir. Benchmarks were conducted on a machine with an AMD Ryzen 9 3950X (32) @ 3.500GHz CPU and 32GB of RAM. The mix fast_html.bench task can be used for running the benchmark by yourself. File/Parserfast_html (Port)mochiweb_html (erlang)html5ever (Rust NIF)Myhtmlex (NIF)¹ document-large.html (6.9M)125.12 ms1778.34 ms395.21 ms327.17 ms document-medium.html (85K)1.93 ms12.10 ms4.74 ms3.82 ms document-small.html (25K)0.50 ms2.76 ms1.72 ms1.19 ms fragment-large.html (33K)0.93 ms4.78 ms2.34 ms2.15 ms fragment-small.html² (757B)44.60 μs42.13 μs43.58 μs289.71 μs Full benchmark output can be seen in this snippet Myhtmlex has a C-Node mode, but it wasn&#39;t benchmarked here because it segfaults on document-large.html The slowdown on fragment-small.html is due to Port overhead. Unlike html5ever and Myhtmlex in NIF mode, fast_html has the parser process isolated and communicates with it over stdio, so even if a fatal crash in the parser happens, it won&#39;t bring down the entire VM."},{"ref":"readme.html#contribution-bug-reports","title":"FastHTML - Contribution / Bug Reports","type":"extras","doc":"Please make sure you do git submodule update after a checkout/pull The project aims to be fully tested"}]